rgw - Bug #39995

rgw: make check is failing because of linker error on Ubuntu
05/22/2019 08:22 AM - Tatjana Dehler

Status: Resolved % Done: 0%
Priority: Urgent Spent time: 0.00 hour
Assignee: Casey Bodley

Category:

Target version:

Source: Development Affected Versions:

Tags: ceph-qa-suite:

Backport: Pull request ID:
Regression: No Crash signature (v1):
Severity: 3 - minor Crash signature (v2):
Reviewed:

Description

It happens only on Ubuntu, CentOS is fine:

e https://jenkins.ceph.com/job/ceph-pull-requests/359/consoleFull
e https:/jenkins.ceph.com/job/ceph-pull-requests/490/consoleFull

/usr/bin/1ld: warning: libboost_context.so.1.67.0, needed by //opt/ceph/lib/x86_64-1inux-gnu/libboo
st_coroutine.so.1.67.0, not found (try using -rpath or -rpath-link)
//opt/ceph/1lib/x86_64-1inux—-gnu/libboost_coroutine.so.1.67.0: undefined reference to "~ jump_fcontex
tV

//opt/ceph/1lib/x86_64-1inux—-gnu/libboost_coroutine.so.1.67.0: undefined reference to “make_fcontex
tV

collect2: error: 1d returned 1 exit status

Link Error: RGW library not found

LINK test/unit/lib/iscsi/init_grp.c/init_grp_ut
src/pybind/rgw/CMakeFiles/cython_rgw.dir/build.make:57: recipe for target 'src/pybind/rgw/CMakeFil
es/cython_rgw' failed
make[3]: *** [src/pybind/rgw/CMakeFiles/cython_rgw] Error 1
CMakeFiles/Makefile2:5456: recipe for target 'src/pybind/rgw/CMakeFiles/cython_rgw.dir/all' failed
make[2]: *** [src/pybind/rgw/CMakeFiles/cython_rgw.dir/all] Error 2

History

#1 - 05/22/2019 08:26 AM - Sebastian Wagner
- Status changed from New to 12

- Priority changed from Normal to Urgent

All builds are failing:

https://jenkins.ceph.com/job/ceph-pull-r 4 nsol
https://jenkins.ceph.com/job/ceph-pull-requests/496/console
https://jenkins.ceph.com/job/ceph-pull-requests/497/console

#2 - 05/22/2019 09:51 AM - Nathan Cutler
- Related to Bug #39981: do_cmake.sh: "source" not found added
https://jenkins.ceph.com/job/ceph-pull-requests/359/consoleFull
https://jenkins.ceph.com/job/ceph-pull-requests/490/consoleFull
https://jenkins.ceph.com/job/ceph-pull-requests/495/console
https://jenkins.ceph.com/job/ceph-pull-requests/496/console
https://jenkins.ceph.com/job/ceph-pull-requests/497/console

#3 - 05/22/2019 09:51 AM - Nathan Cutler
Maybe this is the root cause? #39981

#4 - 05/22/2019 04:43 PM - Nathan Cutler

All of the console logs are from a single PR: https:/github.com/ceph/ceph/pull/19371

And "make check" just passed in that PR following merge of https:/github.com/ceph/ceph/pull/28181 which is. . . a positive sign.

#5 - 05/22/2019 06:36 PM - Sebastian Wagner
https://github.com/ceph/ceph/pull/28058

#6 - 05/23/2019 07:56 AM - Nathan Cutler
Still happening: https:/github.com/ceph/ceph/pull/28211

So I'm removing the related-to link to #39981.

#7 - 05/23/2019 07:57 AM - Nathan Cutler
- Related to deleted (Bug #39981: do_cmake.sh: "source" not found)

#8 - 05/23/2019 11:20 AM - Sebastian Wagner

https://jenkins.ceph.com/job/ceph-pull-requests/556/console

#9 - 05/23/2019 11:23 AM - Sebastian Wagner
- Assignee set to Casey Bodley

(Ceasy, assigned to you, just to make you aware of this.)

#10 - 05/23/2019 01:40 PM - Sebastian Wagner
https://jenkins.ceph.com/job/ceph-pull-r nsol

#11 - 05/23/2019 01:45 PM - Sebastian Wagner

https://jenkins.ceph.com/job/ceph-pull-requests/573/console

#12 - 05/24/2019 12:27 PM - Casey Bodley

| set up a fresh bionic vm and was able to build master successfully. The ubuntu flavors of master and nautilus are still succeeding in
https://shaman.ceph.com/builds/ceph/. It looks like the difference here is the use of WITH_SYSTEM_BOOST and the ceph-libboost-* packages.

From the logs of failures, | do see that cmake is able to find the boost context component:

—-— Boost version: 1.67.0
-— Found the following Boost libraries:
== atomic

== chrono

== thread

== system

. regex

== random

== program_options

== date_time

== iostreams

== python27

== context

e coroutine

== filesystem
== timer

But the failure implies that libboost_context.so isn't present under /opt/ceph/:

/usr/bin/ld: warning: libboost_context.so.1.67.0, needed by //opt/ceph/lib/x86_64-1inux-gnu/libboost_coroutine
.s0.1.67.0, not found (try using -rpath or -rpath-link)

#13 - 05/24/2019 06:28 PM - Casey Bodley

The logs of failures seem to be using xenial:

++ VERSION='16.04.4 LTS (Xenial Xerus)'

So | created a xenial vm and again built successfully with:

cmake -DWITH_SYSTEM_BOOST=ON -DBOOST_ROOT=/opt/ceph ..

#14 - 05/24/2019 09:11 PM - Luis Henriques

Maybe just a shot in the dark, but can't the problem be in the libboost-* libs being installed? The "undefined reference" error occurs in
libboost_coroutine.so.1.67.0, which is installed from some https:/chacra.ceph.com/repos/... URL. Are these libs sane, or could they be already
broken?

#15 - 05/26/2019 06:55 PM - Kefu Chai
td;dr ceph-libboost1.67-dev_1.67.0-7_amd64.deb was not sane.

long story,

1. before https:/github.com/tchaikov/ceph-boost/commit/ec205d3f54258c0d7f9d22ae279b1a20523e7629 was merged, we could consistently
reproduce this issue.

2. | tried to fix it by rebuilding the ceph-libboost* packages and uploading them to chacra. but i failed to reinstall them to all xenial builders.

3. and re-running install-deps.sh cannot help because:

o j was using the same changelog file when rebuilding the ceph-libboost* packages. as i thought it would be simpler to fix the builders than
updating install-deps.sh, if the ceph-libboost* packages went wrong. so the new ceph-libboost* packages are of the same version as the old
ones.

o if the package with the same name was already installed, install-deps.sh won't reinstall it. see
https://github.com/ceph/ceph/blob/b97022ce553d278c60524950ca3b16825dac0839/install-deps.sh#L.136-L.140

4.ireinstalled the new package of ceph-libboost1.67-dev_1.67.0-7_amd64.deb on all ubuntu builders by reissuing "retest this please" command to
jenkins, and ensuring all ubuntu builders are running the build job of https://github.com/ceph/ceph/pull/28245.
#16 - 05/28/2019 10:49 AM - Nathan Cutler
- Assignee changed from Casey Bodley to Kefu Chai

Thanks for fixing the issue, Kefu! Can this be marked Resolved now?

#17 - 05/28/2019 12:10 PM - Casey Bodley
- Assignee changed from Kefu Chai to Casey Bodley

Thanks Kefu, you are my hero.

#18 - 05/29/2019 01:20 PM - Casey Bodley

- Status changed from 12 to Resolved
